/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#pragma once

#include <functional>
#include <vector>

template <typename T> class EventEmitter
{

  public:
	void registerCallback(std::function<void(T)> func)
	{
		callbacks.push_back(func);
	}

	void emit(T data)
	{
		for (auto &callback : callbacks) {
			callback(data);
		}
	}

  private:
	std::vector<std::function<void(T)>> callbacks;
};
